/* deb822.c generated by valac 0.56.17, the Vala compiler
 * generated from deb822.vala, do not modify */

/* Copyright (C) 2014 Canonical Ltd.
 * Author: Colin Watson <cjwatson@ubuntu.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/* Simple deb822-like file parsing. */

#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib-object.h>
#include "click.h"

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_io_channel_unref0(var) ((var == NULL) ? NULL : (var = (g_io_channel_unref (var), NULL)))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))

VALA_EXTERN GRegex* click_field_re;
GRegex* click_field_re = NULL;
VALA_EXTERN GRegex* click_blank_re;
GRegex* click_blank_re = NULL;

VALA_EXTERN GeeMap* click_parse_deb822_file (const gchar* path,
                                 GError** error);

/**
 * parse_deb822_file:
 * @path: Path to a file.
 *
 * A very simple deb822-like file parser.
 *
 * Note that this only supports a single paragraph composed only of simple
 * (non-folded/multiline) fields, which is fortunately all we need in Click.
 *
 * Returns: A mapping of field names to values.
 */
GeeMap*
click_parse_deb822_file (const gchar* path,
                         GError** error)
{
	GRegex* _tmp0_;
	GRegex* _tmp4_;
	GeeHashMap* ret = NULL;
	GeeHashMap* _tmp8_;
	GIOChannel* channel = NULL;
	GIOChannel* _tmp9_;
	gchar* line = NULL;
	GError* _inner_error0_ = NULL;
	GeeMap* result;
#line 35 "deb822.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 38 "deb822.vala"
	_tmp0_ = click_field_re;
#line 38 "deb822.vala"
	if (_tmp0_ == NULL) {
#line 82 "deb822.c"
		GRegex* _tmp1_ = NULL;
		GRegex* _tmp2_;
		GRegex* _tmp3_;
#line 39 "deb822.vala"
		_tmp2_ = g_regex_new ("^([^:[:space:]]+)[[:space:]]*:[[:space:]]" "([^[:space:]].*?)[[:space:]]*$", 0, 0, &_inner_error0_);
#line 39 "deb822.vala"
		_tmp1_ = _tmp2_;
#line 39 "deb822.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 39 "deb822.vala"
			g_propagate_error (error, _inner_error0_);
#line 39 "deb822.vala"
			return NULL;
#line 96 "deb822.c"
		}
#line 39 "deb822.vala"
		_tmp3_ = _tmp1_;
#line 39 "deb822.vala"
		_tmp1_ = NULL;
#line 39 "deb822.vala"
		_g_regex_unref0 (click_field_re);
#line 39 "deb822.vala"
		click_field_re = _tmp3_;
#line 38 "deb822.vala"
		_g_regex_unref0 (_tmp1_);
#line 108 "deb822.c"
	}
#line 42 "deb822.vala"
	_tmp4_ = click_blank_re;
#line 42 "deb822.vala"
	if (_tmp4_ == NULL) {
#line 114 "deb822.c"
		GRegex* _tmp5_ = NULL;
		GRegex* _tmp6_;
		GRegex* _tmp7_;
#line 43 "deb822.vala"
		_tmp6_ = g_regex_new ("^[[:space:]]*$", 0, 0, &_inner_error0_);
#line 43 "deb822.vala"
		_tmp5_ = _tmp6_;
#line 43 "deb822.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 43 "deb822.vala"
			g_propagate_error (error, _inner_error0_);
#line 43 "deb822.vala"
			return NULL;
#line 128 "deb822.c"
		}
#line 43 "deb822.vala"
		_tmp7_ = _tmp5_;
#line 43 "deb822.vala"
		_tmp5_ = NULL;
#line 43 "deb822.vala"
		_g_regex_unref0 (click_blank_re);
#line 43 "deb822.vala"
		click_blank_re = _tmp7_;
#line 42 "deb822.vala"
		_g_regex_unref0 (_tmp5_);
#line 140 "deb822.c"
	}
#line 45 "deb822.vala"
	_tmp8_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 45 "deb822.vala"
	ret = _tmp8_;
#line 46 "deb822.vala"
	_tmp9_ = g_io_channel_new_file (path, "r", &_inner_error0_);
#line 46 "deb822.vala"
	channel = _tmp9_;
#line 46 "deb822.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 46 "deb822.vala"
		g_propagate_error (error, _inner_error0_);
#line 46 "deb822.vala"
		_g_object_unref0 (ret);
#line 46 "deb822.vala"
		return NULL;
#line 158 "deb822.c"
	}
#line 48 "deb822.vala"
	while (TRUE) {
#line 162 "deb822.c"
		gboolean _tmp10_ = FALSE;
		GIOStatus _tmp11_ = 0;
		GIOChannel* _tmp12_;
		gchar* _tmp13_ = NULL;
		GIOStatus _tmp14_;
		GMatchInfo* match_info = NULL;
		GRegex* _tmp16_;
		const gchar* _tmp17_;
		GRegex* _tmp18_;
		const gchar* _tmp19_;
		GMatchInfo* _tmp20_ = NULL;
		gboolean _tmp21_;
#line 48 "deb822.vala"
		_tmp12_ = channel;
#line 48 "deb822.vala"
		_tmp14_ = g_io_channel_read_line (_tmp12_, &_tmp13_, NULL, NULL, &_inner_error0_);
#line 48 "deb822.vala"
		_g_free0 (line);
#line 48 "deb822.vala"
		line = _tmp13_;
#line 48 "deb822.vala"
		_tmp11_ = _tmp14_;
#line 48 "deb822.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 48 "deb822.vala"
			g_propagate_error (error, _inner_error0_);
#line 48 "deb822.vala"
			_g_free0 (line);
#line 48 "deb822.vala"
			_g_io_channel_unref0 (channel);
#line 48 "deb822.vala"
			_g_object_unref0 (ret);
#line 48 "deb822.vala"
			return NULL;
#line 197 "deb822.c"
		}
#line 48 "deb822.vala"
		if (_tmp11_ == G_IO_STATUS_NORMAL) {
#line 201 "deb822.c"
			const gchar* _tmp15_;
#line 49 "deb822.vala"
			_tmp15_ = line;
#line 49 "deb822.vala"
			_tmp10_ = _tmp15_ != NULL;
#line 207 "deb822.c"
		} else {
#line 48 "deb822.vala"
			_tmp10_ = FALSE;
#line 211 "deb822.c"
		}
#line 48 "deb822.vala"
		if (!_tmp10_) {
#line 48 "deb822.vala"
			break;
#line 217 "deb822.c"
		}
#line 52 "deb822.vala"
		_tmp16_ = click_blank_re;
#line 52 "deb822.vala"
		_tmp17_ = line;
#line 52 "deb822.vala"
		if (g_regex_match (_tmp16_, _tmp17_, 0, NULL)) {
#line 53 "deb822.vala"
			_g_match_info_unref0 (match_info);
#line 53 "deb822.vala"
			break;
#line 229 "deb822.c"
		}
#line 55 "deb822.vala"
		_tmp18_ = click_field_re;
#line 55 "deb822.vala"
		_tmp19_ = line;
#line 55 "deb822.vala"
		_tmp21_ = g_regex_match (_tmp18_, _tmp19_, 0, &_tmp20_);
#line 55 "deb822.vala"
		_g_match_info_unref0 (match_info);
#line 55 "deb822.vala"
		match_info = _tmp20_;
#line 55 "deb822.vala"
		if (_tmp21_) {
#line 243 "deb822.c"
			gchar* key = NULL;
			GMatchInfo* _tmp22_;
			gchar* _tmp23_;
			gchar* value = NULL;
			GMatchInfo* _tmp24_;
			gchar* _tmp25_;
			gboolean _tmp26_ = FALSE;
			const gchar* _tmp27_;
#line 56 "deb822.vala"
			_tmp22_ = match_info;
#line 56 "deb822.vala"
			_tmp23_ = g_match_info_fetch (_tmp22_, 1);
#line 56 "deb822.vala"
			key = _tmp23_;
#line 57 "deb822.vala"
			_tmp24_ = match_info;
#line 57 "deb822.vala"
			_tmp25_ = g_match_info_fetch (_tmp24_, 2);
#line 57 "deb822.vala"
			value = _tmp25_;
#line 58 "deb822.vala"
			_tmp27_ = key;
#line 58 "deb822.vala"
			if (_tmp27_ != NULL) {
#line 268 "deb822.c"
				const gchar* _tmp28_;
#line 58 "deb822.vala"
				_tmp28_ = value;
#line 58 "deb822.vala"
				_tmp26_ = _tmp28_ != NULL;
#line 274 "deb822.c"
			} else {
#line 58 "deb822.vala"
				_tmp26_ = FALSE;
#line 278 "deb822.c"
			}
#line 58 "deb822.vala"
			if (_tmp26_) {
#line 282 "deb822.c"
				GeeHashMap* _tmp29_;
				const gchar* _tmp30_;
				gchar* _tmp31_;
				gchar* _tmp32_;
				const gchar* _tmp33_;
#line 59 "deb822.vala"
				_tmp29_ = ret;
#line 59 "deb822.vala"
				_tmp30_ = key;
#line 59 "deb822.vala"
				_tmp31_ = g_utf8_strdown (_tmp30_, (gssize) -1);
#line 59 "deb822.vala"
				_tmp32_ = _tmp31_;
#line 59 "deb822.vala"
				_tmp33_ = value;
#line 59 "deb822.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp29_, _tmp32_, _tmp33_);
#line 59 "deb822.vala"
				_g_free0 (_tmp32_);
#line 302 "deb822.c"
			}
#line 55 "deb822.vala"
			_g_free0 (value);
#line 55 "deb822.vala"
			_g_free0 (key);
#line 308 "deb822.c"
		}
#line 48 "deb822.vala"
		_g_match_info_unref0 (match_info);
#line 312 "deb822.c"
	}
#line 62 "deb822.vala"
	result = (GeeMap*) ret;
#line 62 "deb822.vala"
	_g_free0 (line);
#line 62 "deb822.vala"
	_g_io_channel_unref0 (channel);
#line 62 "deb822.vala"
	return result;
#line 322 "deb822.c"
}

