/* framework.c generated by valac 0.56.17, the Vala compiler
 * generated from framework.vala, do not modify */

/* Copyright (C) 2014 Canonical Ltd.
 * Author: Colin Watson <cjwatson@ubuntu.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/* Click frameworks. */

#include "click.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	CLICK_FRAMEWORK_0_PROPERTY,
	CLICK_FRAMEWORK_NAME_PROPERTY,
	CLICK_FRAMEWORK_NUM_PROPERTIES
};
static GParamSpec* click_framework_properties[CLICK_FRAMEWORK_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define CLICK_DIR_TYPE_ITERATOR (click_dir_iterator_get_type ())
#define CLICK_DIR_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CLICK_DIR_TYPE_ITERATOR, ClickDirIterator))
#define CLICK_DIR_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CLICK_DIR_TYPE_ITERATOR, ClickDirIteratorClass))
#define CLICK_DIR_IS_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CLICK_DIR_TYPE_ITERATOR))
#define CLICK_DIR_IS_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CLICK_DIR_TYPE_ITERATOR))
#define CLICK_DIR_ITERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CLICK_DIR_TYPE_ITERATOR, ClickDirIteratorClass))

typedef struct _ClickDirIterator ClickDirIterator;
typedef struct _ClickDirIteratorClass ClickDirIteratorClass;

struct _ClickFrameworkPrivate {
	gchar* _name;
	GeeMap* fields;
};

static gint ClickFramework_private_offset;
static gpointer click_framework_parent_class = NULL;

static ClickFramework* click_framework_new (const gchar* name);
static ClickFramework* click_framework_construct (GType object_type,
                                           const gchar* name);
VALA_EXTERN GeeMap* click_parse_deb822_file (const gchar* path,
                                 GError** error);
VALA_EXTERN gboolean click_exists (const gchar* path);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
VALA_EXTERN GType click_dir_iterator_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ClickDirIterator* click_dir_iterator (ClickDir* self);
VALA_EXTERN const gchar* click_dir_iterator_next_value (ClickDirIterator* self);
static void click_framework_finalize (GObject * obj);
static GType click_framework_get_type_once (void);
static void _vala_click_framework_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_click_framework_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);

GQuark
click_framework_error_quark (void)
{
	return g_quark_from_static_string ("click-framework-error-quark");
}

static GType
click_framework_error_get_type_once (void)
{
	static const GEnumValue values[] = {{CLICK_FRAMEWORK_ERROR_NO_SUCH_FRAMEWORK, "CLICK_FRAMEWORK_ERROR_NO_SUCH_FRAMEWORK", "no-such-framework"}, {CLICK_FRAMEWORK_ERROR_MISSING_FIELD, "CLICK_FRAMEWORK_ERROR_MISSING_FIELD", "missing-field"}, {0, NULL, NULL}};
	GType click_framework_error_type_id;
	click_framework_error_type_id = g_enum_register_static ("ClickFrameworkError", values);
	return click_framework_error_type_id;
}

GType
click_framework_error_get_type (void)
{
	static volatile gsize click_framework_error_type_id__once = 0;
	if (g_once_init_enter (&click_framework_error_type_id__once)) {
		GType click_framework_error_type_id;
		click_framework_error_type_id = click_framework_error_get_type_once ();
		g_once_init_leave (&click_framework_error_type_id__once, click_framework_error_type_id);
	}
	return click_framework_error_type_id__once;
}

static inline gpointer
click_framework_get_instance_private (ClickFramework* self)
{
	return G_STRUCT_MEMBER_P (self, ClickFramework_private_offset);
}

static ClickFramework*
click_framework_construct (GType object_type,
                           const gchar* name)
{
	ClickFramework * self = NULL;
#line 37 "framework.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 40 "framework.vala"
	self = (ClickFramework*) g_object_new (object_type, "name", name, NULL);
#line 37 "framework.vala"
	return self;
#line 131 "framework.c"
}

static ClickFramework*
click_framework_new (const gchar* name)
{
#line 37 "framework.vala"
	return click_framework_construct (CLICK_TYPE_FRAMEWORK, name);
#line 139 "framework.c"
}

/**
 * Framework.open:
 * @name: The name of the framework to open.
 *
 * Returns: (transfer full): A newly-allocated #Click.Framework.
 *
 * Since: 0.4.18
 */
static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1624 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1625 "glib-2.0.vapi"
	result = self;
#line 1625 "glib-2.0.vapi"
	return result;
#line 160 "framework.c"
}

ClickFramework*
click_framework_open (const gchar* name,
                      GError** error)
{
	gchar* path = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GError* _inner_error0_ = NULL;
	ClickFramework* result;
#line 51 "framework.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 54 "framework.vala"
	_tmp0_ = click_get_frameworks_dir ();
#line 54 "framework.vala"
	_tmp1_ = _tmp0_;
#line 54 "framework.vala"
	_tmp2_ = string_to_string (name);
#line 54 "framework.vala"
	_tmp3_ = g_strconcat (_tmp2_, ".framework", NULL);
#line 54 "framework.vala"
	_tmp4_ = _tmp3_;
#line 54 "framework.vala"
	_tmp5_ = g_build_filename (_tmp1_, _tmp4_, NULL);
#line 54 "framework.vala"
	_tmp6_ = _tmp5_;
#line 54 "framework.vala"
	_g_free0 (_tmp4_);
#line 54 "framework.vala"
	_g_free0 (_tmp1_);
#line 54 "framework.vala"
	path = _tmp6_;
#line 199 "framework.c"
	{
		ClickFramework* framework = NULL;
		ClickFramework* _tmp7_;
		GeeMap* _tmp8_ = NULL;
		const gchar* _tmp9_;
		GeeMap* _tmp10_;
		ClickFramework* _tmp11_;
		GeeMap* _tmp12_;
#line 57 "framework.vala"
		_tmp7_ = click_framework_new (name);
#line 57 "framework.vala"
		framework = _tmp7_;
#line 58 "framework.vala"
		_tmp9_ = path;
#line 58 "framework.vala"
		_tmp10_ = click_parse_deb822_file (_tmp9_, &_inner_error0_);
#line 58 "framework.vala"
		_tmp8_ = _tmp10_;
#line 58 "framework.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 58 "framework.vala"
			_g_object_unref0 (framework);
#line 222 "framework.c"
			goto __catch0_g_error;
		}
#line 58 "framework.vala"
		_tmp11_ = framework;
#line 58 "framework.vala"
		_tmp12_ = _tmp8_;
#line 58 "framework.vala"
		_tmp8_ = NULL;
#line 58 "framework.vala"
		_g_object_unref0 (_tmp11_->priv->fields);
#line 58 "framework.vala"
		_tmp11_->priv->fields = _tmp12_;
#line 59 "framework.vala"
		result = framework;
#line 59 "framework.vala"
		_g_object_unref0 (_tmp8_);
#line 59 "framework.vala"
		_g_free0 (path);
#line 59 "framework.vala"
		return result;
#line 243 "framework.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _tmp13_;
#line 56 "framework.vala"
		g_clear_error (&_inner_error0_);
#line 61 "framework.vala"
		_tmp13_ = g_error_new (CLICK_FRAMEWORK_ERROR, CLICK_FRAMEWORK_ERROR_NO_SUCH_FRAMEWORK, "No click framework '%s' installed", name);
#line 61 "framework.vala"
		_inner_error0_ = _tmp13_;
#line 255 "framework.c"
		goto __finally0;
	}
	__finally0:
#line 56 "framework.vala"
	if (_inner_error0_->domain == CLICK_FRAMEWORK_ERROR) {
#line 56 "framework.vala"
		g_propagate_error (error, _inner_error0_);
#line 56 "framework.vala"
		_g_free0 (path);
#line 56 "framework.vala"
		return NULL;
#line 267 "framework.c"
	} else {
#line 56 "framework.vala"
		_g_free0 (path);
#line 56 "framework.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 56 "framework.vala"
		g_clear_error (&_inner_error0_);
#line 56 "framework.vala"
		return NULL;
#line 277 "framework.c"
	}
}

/**
 * has_framework:
 * @name: A framework name.
 *
 * Returns: True if a framework by this name exists, otherwise false.
 *
 * Since: 0.4.18
 */
gboolean
click_framework_has_framework (const gchar* name)
{
	gchar* path = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gboolean result;
#line 74 "framework.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 77 "framework.vala"
	_tmp0_ = click_get_frameworks_dir ();
#line 77 "framework.vala"
	_tmp1_ = _tmp0_;
#line 77 "framework.vala"
	_tmp2_ = string_to_string (name);
#line 77 "framework.vala"
	_tmp3_ = g_strconcat (_tmp2_, ".framework", NULL);
#line 77 "framework.vala"
	_tmp4_ = _tmp3_;
#line 77 "framework.vala"
	_tmp5_ = g_build_filename (_tmp1_, _tmp4_, NULL);
#line 77 "framework.vala"
	_tmp6_ = _tmp5_;
#line 77 "framework.vala"
	_g_free0 (_tmp4_);
#line 77 "framework.vala"
	_g_free0 (_tmp1_);
#line 77 "framework.vala"
	path = _tmp6_;
#line 79 "framework.vala"
	result = click_exists (path);
#line 79 "framework.vala"
	_g_free0 (path);
#line 79 "framework.vala"
	return result;
#line 329 "framework.c"
}

/**
 * get_frameworks:
 *
 * Returns: (element-type ClickFramework) (transfer full): A #List
 * of all #Click.Framework instances installed on the system.
 *
 * Since: 0.4.18
 */
static void
_g_object_unref0_ (gpointer var)
{
#line 96 "framework.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 345 "framework.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 96 "framework.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 353 "framework.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1535 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1535 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1536 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1537 "glib-2.0.vapi"
		start = string_length + start;
#line 380 "framework.c"
	}
#line 1539 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1540 "glib-2.0.vapi"
		end = string_length + end;
#line 386 "framework.c"
	}
#line 1542 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 392 "framework.c"
	} else {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 396 "framework.c"
	}
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1543 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 404 "framework.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 408 "framework.c"
	}
#line 1543 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1544 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1545 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1545 "glib-2.0.vapi"
	result = _tmp4_;
#line 1545 "glib-2.0.vapi"
	return result;
#line 420 "framework.c"
}

GList*
click_framework_get_frameworks (void)
{
	GList* ret = NULL;
	ClickDir* dir = NULL;
	GError* _inner_error0_ = NULL;
	GList* result;
#line 93 "framework.vala"
	ret = NULL;
#line 432 "framework.c"
	{
		ClickDir* _tmp0_ = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
		ClickDir* _tmp3_;
		ClickDir* _tmp4_;
		ClickDir* _tmp5_;
#line 96 "framework.vala"
		_tmp1_ = click_get_frameworks_dir ();
#line 96 "framework.vala"
		_tmp2_ = _tmp1_;
#line 96 "framework.vala"
		_tmp3_ = click_dir_open (_tmp2_, (guint) 0, &_inner_error0_);
#line 96 "framework.vala"
		_tmp4_ = _tmp3_;
#line 96 "framework.vala"
		_g_free0 (_tmp2_);
#line 96 "framework.vala"
		_tmp0_ = _tmp4_;
#line 96 "framework.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 96 "framework.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 456 "framework.c"
				goto __catch0_g_file_error;
			}
#line 96 "framework.vala"
			_g_object_unref0 (dir);
#line 96 "framework.vala"
			(ret == NULL) ? NULL : (ret = (_g_list_free__g_object_unref0_ (ret), NULL));
#line 96 "framework.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 96 "framework.vala"
			g_clear_error (&_inner_error0_);
#line 96 "framework.vala"
			return NULL;
#line 469 "framework.c"
		}
#line 96 "framework.vala"
		_tmp5_ = _tmp0_;
#line 96 "framework.vala"
		_tmp0_ = NULL;
#line 96 "framework.vala"
		_g_object_unref0 (dir);
#line 96 "framework.vala"
		dir = _tmp5_;
#line 95 "framework.vala"
		_g_object_unref0 (_tmp0_);
#line 481 "framework.c"
	}
	goto __finally0;
	__catch0_g_file_error:
	{
#line 95 "framework.vala"
		g_clear_error (&_inner_error0_);
#line 98 "framework.vala"
		result = ret;
#line 98 "framework.vala"
		_g_object_unref0 (dir);
#line 98 "framework.vala"
		return result;
#line 494 "framework.c"
	}
	__finally0:
#line 95 "framework.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 95 "framework.vala"
		_g_object_unref0 (dir);
#line 95 "framework.vala"
		(ret == NULL) ? NULL : (ret = (_g_list_free__g_object_unref0_ (ret), NULL));
#line 95 "framework.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 95 "framework.vala"
		g_clear_error (&_inner_error0_);
#line 95 "framework.vala"
		return NULL;
#line 509 "framework.c"
	}
	{
		ClickDirIterator* _entry_it = NULL;
		ClickDir* _tmp6_;
		ClickDirIterator* _tmp7_;
		const gchar* entry = NULL;
#line 100 "framework.vala"
		_tmp6_ = dir;
#line 100 "framework.vala"
		_tmp7_ = click_dir_iterator (_tmp6_);
#line 100 "framework.vala"
		_entry_it = _tmp7_;
#line 100 "framework.vala"
		while (TRUE) {
#line 524 "framework.c"
			ClickDirIterator* _tmp8_;
			const gchar* _tmp9_;
			const gchar* _tmp10_;
			const gchar* _tmp11_;
#line 100 "framework.vala"
			_tmp8_ = _entry_it;
#line 100 "framework.vala"
			_tmp9_ = click_dir_iterator_next_value (_tmp8_);
#line 100 "framework.vala"
			entry = _tmp9_;
#line 100 "framework.vala"
			_tmp10_ = entry;
#line 100 "framework.vala"
			if (!(_tmp10_ != NULL)) {
#line 100 "framework.vala"
				break;
#line 541 "framework.c"
			}
#line 101 "framework.vala"
			_tmp11_ = entry;
#line 101 "framework.vala"
			if (!g_str_has_suffix (_tmp11_, ".framework")) {
#line 102 "framework.vala"
				continue;
#line 549 "framework.c"
			}
			{
				ClickFramework* _tmp12_ = NULL;
				const gchar* _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
				ClickFramework* _tmp16_;
				ClickFramework* _tmp17_;
				ClickFramework* _tmp18_;
#line 104 "framework.vala"
				_tmp13_ = entry;
#line 104 "framework.vala"
				_tmp14_ = string_slice (_tmp13_, (glong) 0, (glong) -10);
#line 104 "framework.vala"
				_tmp15_ = _tmp14_;
#line 104 "framework.vala"
				_tmp16_ = click_framework_open (_tmp15_, &_inner_error0_);
#line 104 "framework.vala"
				_tmp17_ = _tmp16_;
#line 104 "framework.vala"
				_g_free0 (_tmp15_);
#line 104 "framework.vala"
				_tmp12_ = _tmp17_;
#line 104 "framework.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 575 "framework.c"
					goto __catch1_g_error;
				}
#line 104 "framework.vala"
				_tmp18_ = _tmp12_;
#line 104 "framework.vala"
				_tmp12_ = NULL;
#line 104 "framework.vala"
				ret = g_list_prepend (ret, _tmp18_);
#line 103 "framework.vala"
				_g_object_unref0 (_tmp12_);
#line 586 "framework.c"
			}
			goto __finally1;
			__catch1_g_error:
			{
#line 103 "framework.vala"
				g_clear_error (&_inner_error0_);
#line 106 "framework.vala"
				continue;
#line 595 "framework.c"
			}
			__finally1:
#line 103 "framework.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 103 "framework.vala"
				_g_object_unref0 (_entry_it);
#line 103 "framework.vala"
				_g_object_unref0 (dir);
#line 103 "framework.vala"
				(ret == NULL) ? NULL : (ret = (_g_list_free__g_object_unref0_ (ret), NULL));
#line 103 "framework.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 103 "framework.vala"
				g_clear_error (&_inner_error0_);
#line 103 "framework.vala"
				return NULL;
#line 612 "framework.c"
			}
		}
#line 100 "framework.vala"
		_g_object_unref0 (_entry_it);
#line 617 "framework.c"
	}
#line 109 "framework.vala"
	ret = g_list_reverse (ret);
#line 110 "framework.vala"
	result = ret;
#line 110 "framework.vala"
	_g_object_unref0 (dir);
#line 110 "framework.vala"
	return result;
#line 627 "framework.c"
}

/**
 * get_fields:
 *
 * Returns: A list of field names defined by this framework.
 *
 * Since: 0.4.18
 */
GList*
click_framework_get_fields (ClickFramework* self)
{
	GList* ret = NULL;
	GList* result;
#line 120 "framework.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 123 "framework.vala"
	ret = NULL;
#line 646 "framework.c"
	{
		GeeIterator* _key_it = NULL;
		GeeMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 124 "framework.vala"
		_tmp0_ = self->priv->fields;
#line 124 "framework.vala"
		_tmp1_ = gee_map_get_keys (_tmp0_);
#line 124 "framework.vala"
		_tmp2_ = _tmp1_;
#line 124 "framework.vala"
		_tmp3_ = _tmp2_;
#line 124 "framework.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 124 "framework.vala"
		_tmp5_ = _tmp4_;
#line 124 "framework.vala"
		_g_object_unref0 (_tmp3_);
#line 124 "framework.vala"
		_key_it = _tmp5_;
#line 124 "framework.vala"
		while (TRUE) {
#line 673 "framework.c"
			GeeIterator* _tmp6_;
			gchar* key = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			const gchar* _tmp9_;
			gchar* _tmp10_;
#line 124 "framework.vala"
			_tmp6_ = _key_it;
#line 124 "framework.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 124 "framework.vala"
				break;
#line 686 "framework.c"
			}
#line 124 "framework.vala"
			_tmp7_ = _key_it;
#line 124 "framework.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 124 "framework.vala"
			key = (gchar*) _tmp8_;
#line 125 "framework.vala"
			_tmp9_ = key;
#line 125 "framework.vala"
			_tmp10_ = g_strdup (_tmp9_);
#line 125 "framework.vala"
			ret = g_list_prepend (ret, _tmp10_);
#line 124 "framework.vala"
			_g_free0 (key);
#line 702 "framework.c"
		}
#line 124 "framework.vala"
		_g_object_unref0 (_key_it);
#line 706 "framework.c"
	}
#line 126 "framework.vala"
	ret = g_list_reverse (ret);
#line 127 "framework.vala"
	result = ret;
#line 127 "framework.vala"
	return result;
#line 714 "framework.c"
}

gchar*
click_framework_get_field (ClickFramework* self,
                           const gchar* key,
                           GError** error)
{
	gchar* value = NULL;
	GeeMap* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gpointer _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 130 "framework.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 130 "framework.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 133 "framework.vala"
	_tmp0_ = self->priv->fields;
#line 133 "framework.vala"
	_tmp1_ = g_utf8_strdown (key, (gssize) -1);
#line 133 "framework.vala"
	_tmp2_ = _tmp1_;
#line 133 "framework.vala"
	_tmp3_ = gee_map_get (_tmp0_, _tmp2_);
#line 133 "framework.vala"
	_tmp4_ = (gchar*) _tmp3_;
#line 133 "framework.vala"
	_g_free0 (_tmp2_);
#line 133 "framework.vala"
	value = _tmp4_;
#line 134 "framework.vala"
	_tmp5_ = value;
#line 134 "framework.vala"
	if (_tmp5_ == NULL) {
#line 753 "framework.c"
		const gchar* _tmp6_;
		GError* _tmp7_;
#line 135 "framework.vala"
		_tmp6_ = self->priv->_name;
#line 135 "framework.vala"
		_tmp7_ = g_error_new (CLICK_FRAMEWORK_ERROR, CLICK_FRAMEWORK_ERROR_MISSING_FIELD, "Framework '%s' has no field named '%s'", _tmp6_, key);
#line 135 "framework.vala"
		_inner_error0_ = _tmp7_;
#line 135 "framework.vala"
		if (_inner_error0_->domain == CLICK_FRAMEWORK_ERROR) {
#line 135 "framework.vala"
			g_propagate_error (error, _inner_error0_);
#line 135 "framework.vala"
			_g_free0 (value);
#line 135 "framework.vala"
			return NULL;
#line 770 "framework.c"
		} else {
#line 135 "framework.vala"
			_g_free0 (value);
#line 135 "framework.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 135 "framework.vala"
			g_clear_error (&_inner_error0_);
#line 135 "framework.vala"
			return NULL;
#line 780 "framework.c"
		}
	}
#line 138 "framework.vala"
	result = value;
#line 138 "framework.vala"
	return result;
#line 787 "framework.c"
}

gchar*
click_framework_get_base_name (ClickFramework* self)
{
	GeeMap* _tmp0_;
	gpointer _tmp1_;
	gchar* result;
#line 141 "framework.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 144 "framework.vala"
	_tmp0_ = self->priv->fields;
#line 144 "framework.vala"
	_tmp1_ = gee_map_get (_tmp0_, "base-name");
#line 144 "framework.vala"
	result = (gchar*) _tmp1_;
#line 144 "framework.vala"
	return result;
#line 806 "framework.c"
}

gchar*
click_framework_get_base_version (ClickFramework* self)
{
	GeeMap* _tmp0_;
	gpointer _tmp1_;
	gchar* result;
#line 147 "framework.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 150 "framework.vala"
	_tmp0_ = self->priv->fields;
#line 150 "framework.vala"
	_tmp1_ = gee_map_get (_tmp0_, "base-version");
#line 150 "framework.vala"
	result = (gchar*) _tmp1_;
#line 150 "framework.vala"
	return result;
#line 825 "framework.c"
}

const gchar*
click_framework_get_name (ClickFramework* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 33 "framework.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "framework.vala"
	_tmp0_ = self->priv->_name;
#line 33 "framework.vala"
	result = _tmp0_;
#line 33 "framework.vala"
	return result;
#line 841 "framework.c"
}

static void
click_framework_set_name (ClickFramework* self,
                          const gchar* value)
{
	gchar* old_value;
#line 33 "framework.vala"
	g_return_if_fail (self != NULL);
#line 33 "framework.vala"
	old_value = click_framework_get_name (self);
#line 33 "framework.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 855 "framework.c"
		gchar* _tmp0_;
#line 33 "framework.vala"
		_tmp0_ = g_strdup (value);
#line 33 "framework.vala"
		_g_free0 (self->priv->_name);
#line 33 "framework.vala"
		self->priv->_name = _tmp0_;
#line 33 "framework.vala"
		g_object_notify_by_pspec ((GObject *) self, click_framework_properties[CLICK_FRAMEWORK_NAME_PROPERTY]);
#line 865 "framework.c"
	}
}

static void
click_framework_class_init (ClickFrameworkClass * klass,
                            gpointer klass_data)
{
#line 32 "framework.vala"
	click_framework_parent_class = g_type_class_peek_parent (klass);
#line 32 "framework.vala"
	g_type_class_adjust_private_offset (klass, &ClickFramework_private_offset);
#line 32 "framework.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_click_framework_get_property;
#line 32 "framework.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_click_framework_set_property;
#line 32 "framework.vala"
	G_OBJECT_CLASS (klass)->finalize = click_framework_finalize;
#line 32 "framework.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLICK_FRAMEWORK_NAME_PROPERTY, click_framework_properties[CLICK_FRAMEWORK_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 885 "framework.c"
}

static void
click_framework_instance_init (ClickFramework * self,
                               gpointer klass)
{
#line 32 "framework.vala"
	self->priv = click_framework_get_instance_private (self);
#line 894 "framework.c"
}

static void
click_framework_finalize (GObject * obj)
{
	ClickFramework * self;
#line 32 "framework.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CLICK_TYPE_FRAMEWORK, ClickFramework);
#line 33 "framework.vala"
	_g_free0 (self->priv->_name);
#line 35 "framework.vala"
	_g_object_unref0 (self->priv->fields);
#line 32 "framework.vala"
	G_OBJECT_CLASS (click_framework_parent_class)->finalize (obj);
#line 909 "framework.c"
}

static GType
click_framework_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ClickFrameworkClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) click_framework_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClickFramework), 0, (GInstanceInitFunc) click_framework_instance_init, NULL };
	GType click_framework_type_id;
	click_framework_type_id = g_type_register_static (G_TYPE_OBJECT, "ClickFramework", &g_define_type_info, 0);
	ClickFramework_private_offset = g_type_add_instance_private (click_framework_type_id, sizeof (ClickFrameworkPrivate));
	return click_framework_type_id;
}

GType
click_framework_get_type (void)
{
	static volatile gsize click_framework_type_id__once = 0;
	if (g_once_init_enter (&click_framework_type_id__once)) {
		GType click_framework_type_id;
		click_framework_type_id = click_framework_get_type_once ();
		g_once_init_leave (&click_framework_type_id__once, click_framework_type_id);
	}
	return click_framework_type_id__once;
}

static void
_vala_click_framework_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	ClickFramework * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CLICK_TYPE_FRAMEWORK, ClickFramework);
#line 32 "framework.vala"
	switch (property_id) {
#line 32 "framework.vala"
		case CLICK_FRAMEWORK_NAME_PROPERTY:
#line 32 "framework.vala"
		g_value_set_string (value, click_framework_get_name (self));
#line 32 "framework.vala"
		break;
#line 950 "framework.c"
		default:
#line 32 "framework.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "framework.vala"
		break;
#line 956 "framework.c"
	}
}

static void
_vala_click_framework_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	ClickFramework * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CLICK_TYPE_FRAMEWORK, ClickFramework);
#line 32 "framework.vala"
	switch (property_id) {
#line 32 "framework.vala"
		case CLICK_FRAMEWORK_NAME_PROPERTY:
#line 32 "framework.vala"
		click_framework_set_name (self, g_value_get_string (value));
#line 32 "framework.vala"
		break;
#line 976 "framework.c"
		default:
#line 32 "framework.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "framework.vala"
		break;
#line 982 "framework.c"
	}
}

