/* osextras.c generated by valac 0.56.17, the Vala compiler
 * generated from osextras.vala, do not modify */

/* Copyright (C) 2013, 2014 Canonical Ltd.
 * Author: Colin Watson <cjwatson@ubuntu.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/* Extra OS-level utility functions.  */

#include "click.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gstdio.h>
#include <errno.h>
#include <gio/gio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	CLICK_DIR_0_PROPERTY,
	CLICK_DIR_NUM_PROPERTIES
};
static GParamSpec* click_dir_properties[CLICK_DIR_NUM_PROPERTIES];
#define _g_dir_close0(var) ((var == NULL) ? NULL : (var = (g_dir_close (var), NULL)))

#define CLICK_DIR_TYPE_ITERATOR (click_dir_iterator_get_type ())
#define CLICK_DIR_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CLICK_DIR_TYPE_ITERATOR, ClickDirIterator))
#define CLICK_DIR_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CLICK_DIR_TYPE_ITERATOR, ClickDirIteratorClass))
#define CLICK_DIR_IS_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CLICK_DIR_TYPE_ITERATOR))
#define CLICK_DIR_IS_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CLICK_DIR_TYPE_ITERATOR))
#define CLICK_DIR_ITERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CLICK_DIR_TYPE_ITERATOR, ClickDirIteratorClass))

typedef struct _ClickDirIterator ClickDirIterator;
typedef struct _ClickDirIteratorClass ClickDirIteratorClass;
typedef struct _ClickDirIteratorPrivate ClickDirIteratorPrivate;
enum  {
	CLICK_DIR_ITERATOR_0_PROPERTY,
	CLICK_DIR_ITERATOR_NUM_PROPERTIES
};
static GParamSpec* click_dir_iterator_properties[CLICK_DIR_ITERATOR_NUM_PROPERTIES];

struct _ClickDirPrivate {
	GSList* entries;
	GSList* cur;
};

struct _ClickDirIterator {
	GObject parent_instance;
	ClickDirIteratorPrivate * priv;
};

struct _ClickDirIteratorClass {
	GObjectClass parent_class;
};

struct _ClickDirIteratorPrivate {
	ClickDir* dir;
};

static gint ClickDir_private_offset;
static gpointer click_dir_parent_class = NULL;
static gint ClickDirIterator_private_offset;
static gpointer click_dir_iterator_parent_class = NULL;

VALA_EXTERN gboolean click_is_dir (const gchar* path);
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
static ClickDir* click_dir_new (void);
static ClickDir* click_dir_construct (GType object_type);
VALA_EXTERN GType click_dir_iterator_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ClickDirIterator* click_dir_iterator (ClickDir* self);
VALA_EXTERN ClickDirIterator* click_dir_iterator_new (ClickDir* dir);
VALA_EXTERN ClickDirIterator* click_dir_iterator_construct (GType object_type,
                                                ClickDir* dir);
VALA_EXTERN const gchar* click_dir_iterator_next_value (ClickDirIterator* self);
static void click_dir_iterator_finalize (GObject * obj);
static GType click_dir_iterator_get_type_once (void);
static void click_dir_finalize (GObject * obj);
static GType click_dir_get_type_once (void);
VALA_EXTERN gboolean click_exists (const gchar* path);
VALA_EXTERN gboolean click_is_symlink (const gchar* path);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

/**
 * find_on_path:
 * @command: A command name.
 *
 * Returns: True if the command is on the executable search path, otherwise
 * false.
 */
gboolean
click_find_on_path (const gchar* command)
{
	const gchar* path = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar** elements = NULL;
	const gchar* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint elements_length1;
	gint _elements_size_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gboolean result;
#line 28 "osextras.vala"
	g_return_val_if_fail (command != NULL, FALSE);
#line 31 "osextras.vala"
	_tmp0_ = g_getenv ("PATH");
#line 31 "osextras.vala"
	path = _tmp0_;
#line 32 "osextras.vala"
	_tmp1_ = path;
#line 32 "osextras.vala"
	if (_tmp1_ == NULL) {
#line 33 "osextras.vala"
		result = FALSE;
#line 33 "osextras.vala"
		return result;
#line 153 "osextras.c"
	}
#line 35 "osextras.vala"
	_tmp2_ = path;
#line 35 "osextras.vala"
	_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, ":", 0);
#line 35 "osextras.vala"
	elements = _tmp4_;
#line 35 "osextras.vala"
	elements_length1 = _vala_array_length (_tmp3_);
#line 35 "osextras.vala"
	_elements_size_ = elements_length1;
#line 36 "osextras.vala"
	_tmp5_ = elements;
#line 36 "osextras.vala"
	_tmp5__length1 = elements_length1;
#line 169 "osextras.c"
	{
		gchar** element_collection = NULL;
		gint element_collection_length1 = 0;
		gint _element_collection_size_ = 0;
		gint element_it = 0;
#line 36 "osextras.vala"
		element_collection = _tmp5_;
#line 36 "osextras.vala"
		element_collection_length1 = _tmp5__length1;
#line 36 "osextras.vala"
		for (element_it = 0; element_it < element_collection_length1; element_it = element_it + 1) {
#line 181 "osextras.c"
			gchar* _tmp6_;
			gchar* element = NULL;
#line 36 "osextras.vala"
			_tmp6_ = g_strdup (element_collection[element_it]);
#line 36 "osextras.vala"
			element = _tmp6_;
#line 188 "osextras.c"
			{
				const gchar* _tmp7_;
				gchar* filename = NULL;
				const gchar* _tmp8_;
				gchar* _tmp9_;
				gboolean _tmp10_ = FALSE;
				const gchar* _tmp11_;
#line 37 "osextras.vala"
				_tmp7_ = element;
#line 37 "osextras.vala"
				if (g_strcmp0 (_tmp7_, "") == 0) {
#line 38 "osextras.vala"
					_g_free0 (element);
#line 38 "osextras.vala"
					continue;
#line 204 "osextras.c"
				}
#line 39 "osextras.vala"
				_tmp8_ = element;
#line 39 "osextras.vala"
				_tmp9_ = g_build_filename (_tmp8_, command, NULL);
#line 39 "osextras.vala"
				filename = _tmp9_;
#line 40 "osextras.vala"
				_tmp11_ = filename;
#line 40 "osextras.vala"
				if (g_file_test (_tmp11_, G_FILE_TEST_IS_REGULAR)) {
#line 216 "osextras.c"
					const gchar* _tmp12_;
#line 41 "osextras.vala"
					_tmp12_ = filename;
#line 41 "osextras.vala"
					_tmp10_ = g_file_test (_tmp12_, G_FILE_TEST_IS_EXECUTABLE);
#line 222 "osextras.c"
				} else {
#line 40 "osextras.vala"
					_tmp10_ = FALSE;
#line 226 "osextras.c"
				}
#line 40 "osextras.vala"
				if (_tmp10_) {
#line 42 "osextras.vala"
					result = TRUE;
#line 42 "osextras.vala"
					_g_free0 (filename);
#line 42 "osextras.vala"
					_g_free0 (element);
#line 42 "osextras.vala"
					elements = (_vala_array_free (elements, elements_length1, (GDestroyNotify) g_free), NULL);
#line 42 "osextras.vala"
					return result;
#line 240 "osextras.c"
				}
#line 36 "osextras.vala"
				_g_free0 (filename);
#line 36 "osextras.vala"
				_g_free0 (element);
#line 246 "osextras.c"
			}
		}
	}
#line 45 "osextras.vala"
	result = FALSE;
#line 45 "osextras.vala"
	elements = (_vala_array_free (elements, elements_length1, (GDestroyNotify) g_free), NULL);
#line 45 "osextras.vala"
	return result;
#line 256 "osextras.c"
}

/**
 * ensuredir:
 * @directory: A path.
 *
 * If @directory does not already exist, create it and its parents as
 * needed.
 */
static gpointer
_g_error_copy0 (gpointer self)
{
#line 66 "osextras.vala"
	return self ? g_error_copy (self) : NULL;
#line 271 "osextras.c"
}

void
click_ensuredir (const gchar* directory,
                 GError** error)
{
	GError* _inner_error0_ = NULL;
#line 55 "osextras.vala"
	g_return_if_fail (directory != NULL);
#line 58 "osextras.vala"
	if (click_is_dir (directory)) {
#line 59 "osextras.vala"
		return;
#line 285 "osextras.c"
	}
#line 60 "osextras.vala"
	if (g_mkdir_with_parents (directory, 0777) < 0) {
#line 289 "osextras.c"
		gint code = 0;
		GQuark quark = 0U;
		GError* err = NULL;
		const gchar* _tmp0_;
		GError* _tmp1_;
		GError* _tmp2_;
		GError* _tmp3_;
#line 61 "osextras.vala"
		code = g_file_error_from_errno (errno);
#line 62 "osextras.vala"
		quark = g_quark_from_string ("g-file-error-quark");
#line 63 "osextras.vala"
		_tmp0_ = g_strerror (errno);
#line 63 "osextras.vala"
		_tmp1_ = g_error_new (quark, code, "ensuredir %s failed: %s", directory, _tmp0_);
#line 63 "osextras.vala"
		err = _tmp1_;
#line 66 "osextras.vala"
		_tmp2_ = err;
#line 66 "osextras.vala"
		_tmp3_ = _g_error_copy0 ((GError*) _tmp2_);
#line 66 "osextras.vala"
		_inner_error0_ = _tmp3_;
#line 66 "osextras.vala"
		if (_inner_error0_->domain == G_FILE_ERROR) {
#line 66 "osextras.vala"
			g_propagate_error (error, _inner_error0_);
#line 66 "osextras.vala"
			_g_error_free0 (err);
#line 66 "osextras.vala"
			return;
#line 321 "osextras.c"
		} else {
#line 66 "osextras.vala"
			_g_error_free0 (err);
#line 66 "osextras.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 66 "osextras.vala"
			g_clear_error (&_inner_error0_);
#line 66 "osextras.vala"
			return;
#line 331 "osextras.c"
		}
#line 60 "osextras.vala"
		_g_error_free0 (err);
#line 335 "osextras.c"
	}
}

/**
 * rmtree:
 * @file: A #File to delete
 *
 * Errors when the directory can not be removed
 */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 84 "osextras.vala"
	return self ? g_object_ref (self) : NULL;
#line 350 "osextras.c"
}

gboolean
click_rmtree (GFile* file,
              GCancellable* cancellable,
              GError** error)
{
	GFileEnumerator* enumerator = NULL;
	GFileEnumerator* _tmp0_;
	gboolean _tmp19_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 76 "osextras.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 79 "osextras.vala"
	_tmp0_ = g_file_enumerate_children (file, G_FILE_ATTRIBUTE_STANDARD_NAME, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, cancellable, &_inner_error0_);
#line 79 "osextras.vala"
	enumerator = _tmp0_;
#line 79 "osextras.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 371 "osextras.c"
		gboolean _tmp1_ = FALSE;
#line 79 "osextras.vala"
		g_propagate_error (error, _inner_error0_);
#line 79 "osextras.vala"
		return _tmp1_;
#line 377 "osextras.c"
	}
#line 82 "osextras.vala"
	while (TRUE) {
#line 381 "osextras.c"
		GFileEnumerator* _tmp2_;
		GFile* child = NULL;
		gboolean _tmp3_ = FALSE;
		GFileEnumerator* _tmp4_;
		GFile* _tmp5_ = NULL;
		gboolean _tmp6_;
		GFile* _tmp7_;
		GFile* _tmp9_;
#line 82 "osextras.vala"
		_tmp2_ = enumerator;
#line 82 "osextras.vala"
		if (!(_tmp2_ != NULL)) {
#line 82 "osextras.vala"
			break;
#line 396 "osextras.c"
		}
#line 84 "osextras.vala"
		_tmp4_ = enumerator;
#line 84 "osextras.vala"
		_tmp6_ = g_file_enumerator_iterate (_tmp4_, NULL, &_tmp5_, cancellable, &_inner_error0_);
#line 84 "osextras.vala"
		_g_object_unref0 (child);
#line 84 "osextras.vala"
		_tmp7_ = _g_object_ref0 (_tmp5_);
#line 84 "osextras.vala"
		child = _tmp7_;
#line 84 "osextras.vala"
		_tmp3_ = _tmp6_;
#line 84 "osextras.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 412 "osextras.c"
			gboolean _tmp8_ = FALSE;
#line 84 "osextras.vala"
			g_propagate_error (error, _inner_error0_);
#line 84 "osextras.vala"
			_g_object_unref0 (child);
#line 84 "osextras.vala"
			_g_object_unref0 (enumerator);
#line 84 "osextras.vala"
			return _tmp8_;
#line 422 "osextras.c"
		}
#line 84 "osextras.vala"
		if (!_tmp3_) {
#line 85 "osextras.vala"
			result = FALSE;
#line 85 "osextras.vala"
			_g_object_unref0 (child);
#line 85 "osextras.vala"
			_g_object_unref0 (enumerator);
#line 85 "osextras.vala"
			return result;
#line 434 "osextras.c"
		}
#line 87 "osextras.vala"
		_tmp9_ = child;
#line 87 "osextras.vala"
		if (_tmp9_ == NULL) {
#line 88 "osextras.vala"
			_g_object_unref0 (child);
#line 88 "osextras.vala"
			break;
#line 444 "osextras.c"
		}
		{
			GFile* _tmp10_;
#line 91 "osextras.vala"
			_tmp10_ = child;
#line 91 "osextras.vala"
			switch (g_file_query_file_type (_tmp10_, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL)) {
#line 91 "osextras.vala"
				case G_FILE_TYPE_DIRECTORY:
#line 454 "osextras.c"
				{
					GFile* _tmp11_;
#line 93 "osextras.vala"
					_tmp11_ = child;
#line 93 "osextras.vala"
					click_rmtree (_tmp11_, cancellable, &_inner_error0_);
#line 93 "osextras.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 463 "osextras.c"
						goto __catch0_g_error;
					}
#line 94 "osextras.vala"
					break;
#line 468 "osextras.c"
				}
				default:
#line 91 "osextras.vala"
				case G_FILE_TYPE_SYMBOLIC_LINK:
#line 473 "osextras.c"
				{
					GFile* _tmp12_;
#line 97 "osextras.vala"
					_tmp12_ = child;
#line 97 "osextras.vala"
					g_file_delete (_tmp12_, cancellable, &_inner_error0_);
#line 97 "osextras.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 482 "osextras.c"
						goto __catch0_g_error;
					}
#line 98 "osextras.vala"
					break;
#line 487 "osextras.c"
				}
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GFile* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			GError* _tmp16_;
			const gchar* _tmp17_;
#line 90 "osextras.vala"
			e = _inner_error0_;
#line 90 "osextras.vala"
			_inner_error0_ = NULL;
#line 101 "osextras.vala"
			_tmp13_ = child;
#line 101 "osextras.vala"
			_tmp14_ = g_file_get_path (_tmp13_);
#line 101 "osextras.vala"
			_tmp15_ = _tmp14_;
#line 101 "osextras.vala"
			_tmp16_ = e;
#line 101 "osextras.vala"
			_tmp17_ = _tmp16_->message;
#line 101 "osextras.vala"
			g_warning ("osextras.vala:101: Error removing '%s': %s", _tmp15_, _tmp17_);
#line 101 "osextras.vala"
			_g_free0 (_tmp15_);
#line 102 "osextras.vala"
			_g_error_free0 (e);
#line 102 "osextras.vala"
			_g_object_unref0 (child);
#line 102 "osextras.vala"
			continue;
#line 524 "osextras.c"
		}
		__finally0:
#line 90 "osextras.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 529 "osextras.c"
			gboolean _tmp18_ = FALSE;
#line 90 "osextras.vala"
			g_propagate_error (error, _inner_error0_);
#line 90 "osextras.vala"
			_g_object_unref0 (child);
#line 90 "osextras.vala"
			_g_object_unref0 (enumerator);
#line 90 "osextras.vala"
			return _tmp18_;
#line 539 "osextras.c"
		}
#line 82 "osextras.vala"
		_g_object_unref0 (child);
#line 543 "osextras.c"
	}
#line 106 "osextras.vala"
	_tmp19_ = g_file_delete (file, cancellable, &_inner_error0_);
#line 106 "osextras.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 549 "osextras.c"
		gboolean _tmp20_ = FALSE;
#line 106 "osextras.vala"
		g_propagate_error (error, _inner_error0_);
#line 106 "osextras.vala"
		_g_object_unref0 (enumerator);
#line 106 "osextras.vala"
		return _tmp20_;
#line 557 "osextras.c"
	}
#line 106 "osextras.vala"
	result = _tmp19_;
#line 106 "osextras.vala"
	_g_object_unref0 (enumerator);
#line 106 "osextras.vala"
	return result;
#line 565 "osextras.c"
}

/**
 * unlink_force:
 * @path: A path to unlink.
 *
 * Unlink path, without worrying about whether it exists.  Errors other than
 * %ENOENT will set the provided error location.
 */
void
click_unlink_force (const gchar* path,
                    GError** error)
{
	gboolean _tmp0_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 116 "osextras.vala"
	g_return_if_fail (path != NULL);
#line 119 "osextras.vala"
	if (g_unlink (path) < 0) {
#line 119 "osextras.vala"
		_tmp0_ = errno != ENOENT;
#line 587 "osextras.c"
	} else {
#line 119 "osextras.vala"
		_tmp0_ = FALSE;
#line 591 "osextras.c"
	}
#line 119 "osextras.vala"
	if (_tmp0_) {
#line 595 "osextras.c"
		gint code = 0;
		GQuark quark = 0U;
		GError* err = NULL;
		const gchar* _tmp1_;
		GError* _tmp2_;
		GError* _tmp3_;
		GError* _tmp4_;
#line 120 "osextras.vala"
		code = g_file_error_from_errno (errno);
#line 121 "osextras.vala"
		quark = g_quark_from_string ("g-file-error-quark");
#line 122 "osextras.vala"
		_tmp1_ = g_strerror (errno);
#line 122 "osextras.vala"
		_tmp2_ = g_error_new (quark, code, "unlink %s failed: %s", path, _tmp1_);
#line 122 "osextras.vala"
		err = _tmp2_;
#line 125 "osextras.vala"
		_tmp3_ = err;
#line 125 "osextras.vala"
		_tmp4_ = _g_error_copy0 ((GError*) _tmp3_);
#line 125 "osextras.vala"
		_inner_error0_ = _tmp4_;
#line 125 "osextras.vala"
		if (_inner_error0_->domain == G_FILE_ERROR) {
#line 125 "osextras.vala"
			g_propagate_error (error, _inner_error0_);
#line 125 "osextras.vala"
			_g_error_free0 (err);
#line 125 "osextras.vala"
			return;
#line 627 "osextras.c"
		} else {
#line 125 "osextras.vala"
			_g_error_free0 (err);
#line 125 "osextras.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 125 "osextras.vala"
			g_clear_error (&_inner_error0_);
#line 125 "osextras.vala"
			return;
#line 637 "osextras.c"
		}
#line 119 "osextras.vala"
		_g_error_free0 (err);
#line 641 "osextras.c"
	}
}

/**
 * symlink_force:
 * @target: The intended target of the symbolic link.
 * @link_name: A path where the symbolic link should be created.
 *
 * Create a symlink link_name -> target, even if link_name exists.
 */
void
click_symlink_force (const gchar* target,
                     const gchar* link_name,
                     GError** error)
{
	GError* _inner_error0_ = NULL;
#line 136 "osextras.vala"
	g_return_if_fail (target != NULL);
#line 136 "osextras.vala"
	g_return_if_fail (link_name != NULL);
#line 139 "osextras.vala"
	click_unlink_force (link_name, &_inner_error0_);
#line 139 "osextras.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 139 "osextras.vala"
		if (_inner_error0_->domain == G_FILE_ERROR) {
#line 139 "osextras.vala"
			g_propagate_error (error, _inner_error0_);
#line 139 "osextras.vala"
			return;
#line 672 "osextras.c"
		} else {
#line 139 "osextras.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 139 "osextras.vala"
			g_clear_error (&_inner_error0_);
#line 139 "osextras.vala"
			return;
#line 680 "osextras.c"
		}
	}
#line 144 "osextras.vala"
	if (symlink (target, link_name) < 0) {
#line 685 "osextras.c"
		gint code = 0;
		GQuark quark = 0U;
		GError* err = NULL;
		const gchar* _tmp0_;
		GError* _tmp1_;
		GError* _tmp2_;
		GError* _tmp3_;
#line 145 "osextras.vala"
		code = g_file_error_from_errno (errno);
#line 146 "osextras.vala"
		quark = g_quark_from_string ("g-file-error-quark");
#line 147 "osextras.vala"
		_tmp0_ = g_strerror (errno);
#line 147 "osextras.vala"
		_tmp1_ = g_error_new (quark, code, "symlink %s -> %s failed: %s", link_name, target, _tmp0_);
#line 147 "osextras.vala"
		err = _tmp1_;
#line 150 "osextras.vala"
		_tmp2_ = err;
#line 150 "osextras.vala"
		_tmp3_ = _g_error_copy0 ((GError*) _tmp2_);
#line 150 "osextras.vala"
		_inner_error0_ = _tmp3_;
#line 150 "osextras.vala"
		if (_inner_error0_->domain == G_FILE_ERROR) {
#line 150 "osextras.vala"
			g_propagate_error (error, _inner_error0_);
#line 150 "osextras.vala"
			_g_error_free0 (err);
#line 150 "osextras.vala"
			return;
#line 717 "osextras.c"
		} else {
#line 150 "osextras.vala"
			_g_error_free0 (err);
#line 150 "osextras.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 150 "osextras.vala"
			g_clear_error (&_inner_error0_);
#line 150 "osextras.vala"
			return;
#line 727 "osextras.c"
		}
#line 144 "osextras.vala"
		_g_error_free0 (err);
#line 731 "osextras.c"
	}
}

/**
 * click_get_umask:
 *
 * Returns: The current umask.
 */
gint
click_get_umask (void)
{
	mode_t mask = {0};
	gint result;
#line 162 "osextras.vala"
	mask = umask ((mode_t) 0);
#line 163 "osextras.vala"
	umask (mask);
#line 164 "osextras.vala"
	result = (gint) mask;
#line 164 "osextras.vala"
	return result;
#line 753 "osextras.c"
}

static inline gpointer
click_dir_get_instance_private (ClickDir* self)
{
	return G_STRUCT_MEMBER_P (self, ClickDir_private_offset);
}

static void
_g_free0_ (gpointer var)
{
#line 168 "osextras.vala"
	var = (g_free (var), NULL);
#line 767 "osextras.c"
}

static inline void
_g_slist_free__g_free0_ (GSList* self)
{
#line 168 "osextras.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
#line 775 "osextras.c"
}

static ClickDir*
click_dir_construct (GType object_type)
{
	ClickDir * self = NULL;
#line 171 "osextras.vala"
	self = (ClickDir*) g_object_new (object_type, NULL);
#line 171 "osextras.vala"
	return self;
#line 786 "osextras.c"
}

static ClickDir*
click_dir_new (void)
{
#line 171 "osextras.vala"
	return click_dir_construct (CLICK_TYPE_DIR);
#line 794 "osextras.c"
}

/**
 * open:
 * @path: The path to the directory to open.
 * @flags: For future use; currently must be set to 0.
 *
 * Like GLib.Dir.open(), but ignores %ENOENT.
 */
ClickDir*
click_dir_open (const gchar* path,
                guint _flags,
                GError** error)
{
	ClickDir* dir = NULL;
	ClickDir* _tmp0_;
	ClickDir* _tmp1_;
	GDir* real_dir = NULL;
	ClickDir* _tmp17_;
	ClickDir* _tmp18_;
	GSList* _tmp19_;
	GError* _inner_error0_ = NULL;
	ClickDir* result;
#line 182 "osextras.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 185 "osextras.vala"
	_tmp0_ = click_dir_new ();
#line 185 "osextras.vala"
	dir = _tmp0_;
#line 186 "osextras.vala"
	_tmp1_ = dir;
#line 186 "osextras.vala"
	(_tmp1_->priv->entries == NULL) ? NULL : (_tmp1_->priv->entries = (_g_slist_free__g_free0_ (_tmp1_->priv->entries), NULL));
#line 186 "osextras.vala"
	_tmp1_->priv->entries = NULL;
#line 830 "osextras.c"
	{
		GDir* _tmp2_ = NULL;
		GDir* _tmp3_;
		GDir* _tmp4_;
		gchar* name = NULL;
		ClickDir* _tmp12_;
		GCompareFunc _tmp13_;
#line 190 "osextras.vala"
		_tmp3_ = g_dir_open (path, _flags, &_inner_error0_);
#line 190 "osextras.vala"
		_tmp2_ = _tmp3_;
#line 190 "osextras.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 190 "osextras.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 846 "osextras.c"
				goto __catch0_g_file_error;
			}
#line 190 "osextras.vala"
			_g_dir_close0 (real_dir);
#line 190 "osextras.vala"
			_g_object_unref0 (dir);
#line 190 "osextras.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 190 "osextras.vala"
			g_clear_error (&_inner_error0_);
#line 190 "osextras.vala"
			return NULL;
#line 859 "osextras.c"
		}
#line 190 "osextras.vala"
		_tmp4_ = _tmp2_;
#line 190 "osextras.vala"
		_tmp2_ = NULL;
#line 190 "osextras.vala"
		_g_dir_close0 (real_dir);
#line 190 "osextras.vala"
		real_dir = _tmp4_;
#line 192 "osextras.vala"
		while (TRUE) {
#line 871 "osextras.c"
			GDir* _tmp5_;
			const gchar* _tmp6_;
			gchar* _tmp7_;
			const gchar* _tmp8_;
			ClickDir* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
#line 192 "osextras.vala"
			_tmp5_ = real_dir;
#line 192 "osextras.vala"
			_tmp6_ = g_dir_read_name (_tmp5_);
#line 192 "osextras.vala"
			_tmp7_ = g_strdup (_tmp6_);
#line 192 "osextras.vala"
			_g_free0 (name);
#line 192 "osextras.vala"
			name = _tmp7_;
#line 192 "osextras.vala"
			_tmp8_ = name;
#line 192 "osextras.vala"
			if (!(_tmp8_ != NULL)) {
#line 192 "osextras.vala"
				break;
#line 895 "osextras.c"
			}
#line 193 "osextras.vala"
			_tmp9_ = dir;
#line 193 "osextras.vala"
			_tmp10_ = name;
#line 193 "osextras.vala"
			_tmp11_ = g_strdup (_tmp10_);
#line 193 "osextras.vala"
			_tmp9_->priv->entries = g_slist_prepend (_tmp9_->priv->entries, _tmp11_);
#line 905 "osextras.c"
		}
#line 194 "osextras.vala"
		_tmp12_ = dir;
#line 194 "osextras.vala"
		_tmp13_ = ((GCompareFunc) g_strcmp0);
#line 194 "osextras.vala"
		_tmp12_->priv->entries = g_slist_sort (_tmp12_->priv->entries, _tmp13_);
#line 189 "osextras.vala"
		_g_free0 (name);
#line 189 "osextras.vala"
		_g_dir_close0 (_tmp2_);
#line 917 "osextras.c"
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp14_;
#line 189 "osextras.vala"
		e = _inner_error0_;
#line 189 "osextras.vala"
		_inner_error0_ = NULL;
#line 196 "osextras.vala"
		_tmp14_ = e;
#line 196 "osextras.vala"
		if (!g_error_matches (_tmp14_, G_FILE_ERROR, G_FILE_ERROR_NOENT)) {
#line 932 "osextras.c"
			GError* _tmp15_;
			GError* _tmp16_;
#line 197 "osextras.vala"
			_tmp15_ = e;
#line 197 "osextras.vala"
			_tmp16_ = _g_error_copy0 (_tmp15_);
#line 197 "osextras.vala"
			_inner_error0_ = _tmp16_;
#line 197 "osextras.vala"
			_g_error_free0 (e);
#line 943 "osextras.c"
			goto __finally0;
		}
#line 189 "osextras.vala"
		_g_error_free0 (e);
#line 948 "osextras.c"
	}
	__finally0:
#line 189 "osextras.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 189 "osextras.vala"
		if (_inner_error0_->domain == G_FILE_ERROR) {
#line 189 "osextras.vala"
			g_propagate_error (error, _inner_error0_);
#line 189 "osextras.vala"
			_g_dir_close0 (real_dir);
#line 189 "osextras.vala"
			_g_object_unref0 (dir);
#line 189 "osextras.vala"
			return NULL;
#line 963 "osextras.c"
		} else {
#line 189 "osextras.vala"
			_g_dir_close0 (real_dir);
#line 189 "osextras.vala"
			_g_object_unref0 (dir);
#line 189 "osextras.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 189 "osextras.vala"
			g_clear_error (&_inner_error0_);
#line 189 "osextras.vala"
			return NULL;
#line 975 "osextras.c"
		}
	}
#line 200 "osextras.vala"
	_tmp17_ = dir;
#line 200 "osextras.vala"
	_tmp18_ = dir;
#line 200 "osextras.vala"
	_tmp19_ = _tmp18_->priv->entries;
#line 200 "osextras.vala"
	_tmp17_->priv->cur = _tmp19_;
#line 201 "osextras.vala"
	result = dir;
#line 201 "osextras.vala"
	_g_dir_close0 (real_dir);
#line 201 "osextras.vala"
	return result;
#line 992 "osextras.c"
}

/**
 * read_name:
 *
 * Like GLib.Dir.read_name(), but returns entries in sorted order.
 */
const gchar*
click_dir_read_name (ClickDir* self)
{
	GSList* _tmp0_;
	const gchar* name = NULL;
	GSList* _tmp1_;
	gconstpointer _tmp2_;
	GSList* _tmp3_;
	GSList* _tmp4_;
	const gchar* _tmp5_;
	const gchar* result;
#line 209 "osextras.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 212 "osextras.vala"
	_tmp0_ = self->priv->cur;
#line 212 "osextras.vala"
	if (_tmp0_ == NULL) {
#line 213 "osextras.vala"
		result = NULL;
#line 213 "osextras.vala"
		return result;
#line 1021 "osextras.c"
	}
#line 214 "osextras.vala"
	_tmp1_ = self->priv->cur;
#line 214 "osextras.vala"
	_tmp2_ = _tmp1_->data;
#line 214 "osextras.vala"
	name = (const gchar*) _tmp2_;
#line 215 "osextras.vala"
	_tmp3_ = self->priv->cur;
#line 215 "osextras.vala"
	_tmp4_ = _tmp3_->next;
#line 215 "osextras.vala"
	self->priv->cur = _tmp4_;
#line 216 "osextras.vala"
	_tmp5_ = name;
#line 216 "osextras.vala"
	result = _tmp5_;
#line 216 "osextras.vala"
	return result;
#line 1041 "osextras.c"
}

ClickDirIterator*
click_dir_iterator (ClickDir* self)
{
	ClickDirIterator* _tmp0_;
	ClickDirIterator* result;
#line 233 "osextras.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 236 "osextras.vala"
	_tmp0_ = click_dir_iterator_new (self);
#line 236 "osextras.vala"
	result = _tmp0_;
#line 236 "osextras.vala"
	return result;
#line 1057 "osextras.c"
}

static inline gpointer
click_dir_iterator_get_instance_private (ClickDirIterator* self)
{
	return G_STRUCT_MEMBER_P (self, ClickDirIterator_private_offset);
}

ClickDirIterator*
click_dir_iterator_construct (GType object_type,
                              ClickDir* dir)
{
	ClickDirIterator * self = NULL;
	ClickDir* _tmp0_;
#line 222 "osextras.vala"
	g_return_val_if_fail (dir != NULL, NULL);
#line 222 "osextras.vala"
	self = (ClickDirIterator*) g_object_new (object_type, NULL);
#line 223 "osextras.vala"
	_tmp0_ = _g_object_ref0 (dir);
#line 223 "osextras.vala"
	_g_object_unref0 (self->priv->dir);
#line 223 "osextras.vala"
	self->priv->dir = _tmp0_;
#line 222 "osextras.vala"
	return self;
#line 1084 "osextras.c"
}

ClickDirIterator*
click_dir_iterator_new (ClickDir* dir)
{
#line 222 "osextras.vala"
	return click_dir_iterator_construct (CLICK_DIR_TYPE_ITERATOR, dir);
#line 1092 "osextras.c"
}

const gchar*
click_dir_iterator_next_value (ClickDirIterator* self)
{
	ClickDir* _tmp0_;
	const gchar* _tmp1_;
	const gchar* result;
#line 226 "osextras.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 229 "osextras.vala"
	_tmp0_ = self->priv->dir;
#line 229 "osextras.vala"
	_tmp1_ = click_dir_read_name (_tmp0_);
#line 229 "osextras.vala"
	result = _tmp1_;
#line 229 "osextras.vala"
	return result;
#line 1111 "osextras.c"
}

static void
click_dir_iterator_class_init (ClickDirIteratorClass * klass,
                               gpointer klass_data)
{
#line 219 "osextras.vala"
	click_dir_iterator_parent_class = g_type_class_peek_parent (klass);
#line 219 "osextras.vala"
	g_type_class_adjust_private_offset (klass, &ClickDirIterator_private_offset);
#line 219 "osextras.vala"
	G_OBJECT_CLASS (klass)->finalize = click_dir_iterator_finalize;
#line 1124 "osextras.c"
}

static void
click_dir_iterator_instance_init (ClickDirIterator * self,
                                  gpointer klass)
{
#line 219 "osextras.vala"
	self->priv = click_dir_iterator_get_instance_private (self);
#line 1133 "osextras.c"
}

static void
click_dir_iterator_finalize (GObject * obj)
{
	ClickDirIterator * self;
#line 219 "osextras.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CLICK_DIR_TYPE_ITERATOR, ClickDirIterator);
#line 220 "osextras.vala"
	_g_object_unref0 (self->priv->dir);
#line 219 "osextras.vala"
	G_OBJECT_CLASS (click_dir_iterator_parent_class)->finalize (obj);
#line 1146 "osextras.c"
}

static GType
click_dir_iterator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ClickDirIteratorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) click_dir_iterator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClickDirIterator), 0, (GInstanceInitFunc) click_dir_iterator_instance_init, NULL };
	GType click_dir_iterator_type_id;
	click_dir_iterator_type_id = g_type_register_static (G_TYPE_OBJECT, "ClickDirIterator", &g_define_type_info, 0);
	ClickDirIterator_private_offset = g_type_add_instance_private (click_dir_iterator_type_id, sizeof (ClickDirIteratorPrivate));
	return click_dir_iterator_type_id;
}

GType
click_dir_iterator_get_type (void)
{
	static volatile gsize click_dir_iterator_type_id__once = 0;
	if (g_once_init_enter (&click_dir_iterator_type_id__once)) {
		GType click_dir_iterator_type_id;
		click_dir_iterator_type_id = click_dir_iterator_get_type_once ();
		g_once_init_leave (&click_dir_iterator_type_id__once, click_dir_iterator_type_id);
	}
	return click_dir_iterator_type_id__once;
}

static void
click_dir_class_init (ClickDirClass * klass,
                      gpointer klass_data)
{
#line 167 "osextras.vala"
	click_dir_parent_class = g_type_class_peek_parent (klass);
#line 167 "osextras.vala"
	g_type_class_adjust_private_offset (klass, &ClickDir_private_offset);
#line 167 "osextras.vala"
	G_OBJECT_CLASS (klass)->finalize = click_dir_finalize;
#line 1181 "osextras.c"
}

static void
click_dir_instance_init (ClickDir * self,
                         gpointer klass)
{
#line 167 "osextras.vala"
	self->priv = click_dir_get_instance_private (self);
#line 1190 "osextras.c"
}

static void
click_dir_finalize (GObject * obj)
{
	ClickDir * self;
#line 167 "osextras.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CLICK_TYPE_DIR, ClickDir);
#line 168 "osextras.vala"
	(self->priv->entries == NULL) ? NULL : (self->priv->entries = (_g_slist_free__g_free0_ (self->priv->entries), NULL));
#line 167 "osextras.vala"
	G_OBJECT_CLASS (click_dir_parent_class)->finalize (obj);
#line 1203 "osextras.c"
}

static GType
click_dir_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ClickDirClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) click_dir_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClickDir), 0, (GInstanceInitFunc) click_dir_instance_init, NULL };
	GType click_dir_type_id;
	click_dir_type_id = g_type_register_static (G_TYPE_OBJECT, "ClickDir", &g_define_type_info, 0);
	ClickDir_private_offset = g_type_add_instance_private (click_dir_type_id, sizeof (ClickDirPrivate));
	return click_dir_type_id;
}

GType
click_dir_get_type (void)
{
	static volatile gsize click_dir_type_id__once = 0;
	if (g_once_init_enter (&click_dir_type_id__once)) {
		GType click_dir_type_id;
		click_dir_type_id = click_dir_get_type_once ();
		g_once_init_leave (&click_dir_type_id__once, click_dir_type_id);
	}
	return click_dir_type_id__once;
}

gboolean
click_exists (const gchar* path)
{
	gboolean result;
#line 240 "osextras.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 243 "osextras.vala"
	result = g_file_test (path, G_FILE_TEST_EXISTS);
#line 243 "osextras.vala"
	return result;
#line 1238 "osextras.c"
}

gboolean
click_is_symlink (const gchar* path)
{
	gboolean result;
#line 246 "osextras.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 249 "osextras.vala"
	result = g_file_test (path, G_FILE_TEST_IS_SYMLINK);
#line 249 "osextras.vala"
	return result;
#line 1251 "osextras.c"
}

gboolean
click_is_dir (const gchar* path)
{
	gboolean result;
#line 252 "osextras.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 255 "osextras.vala"
	result = g_file_test (path, G_FILE_TEST_IS_DIR);
#line 255 "osextras.vala"
	return result;
#line 1264 "osextras.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

