/* Copyright (C) 2013, 2014 Canonical Ltd.
 * Author: Colin Watson <cjwatson@ubuntu.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/* Click paths. */

namespace Click {

internal static const string hooks_dir = "/usr/share/click/hooks";
internal static const string db_dir = "/etc/click/databases";
internal static const string frameworks_dir = "/usr/share/click/frameworks";

/**
 * get_hooks_dir:
 *
 * Returns: The Click hooks directory.
 */
public string
get_hooks_dir ()
{
	return hooks_dir;
}

/**
 * get_db_dir:
 *
 * Returns: The Click database configuration directory.
 */
public string
get_db_dir ()
{
	return db_dir;
}

/**
 * get_frameworks_dir:
 *
 * Returns: The Click frameworks directory.
 */
public string
get_frameworks_dir ()
{
	return frameworks_dir;
}

}
