/* query.c generated by valac 0.56.17, the Vala compiler
 * generated from query.vala, do not modify */

/* Copyright (C) 2013, 2014 Canonical Ltd.
 * Author: Colin Watson <cjwatson@ubuntu.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/* Query information about installed Click packages.  */

#include "click.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <errno.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))

VALA_EXTERN gboolean click_is_dir (const gchar* path);

GQuark
click_query_error_quark (void)
{
	return g_quark_from_static_string ("click-query-error-quark");
}

static GType
click_query_error_get_type_once (void)
{
	static const GEnumValue values[] = {{CLICK_QUERY_ERROR_PATH, "CLICK_QUERY_ERROR_PATH", "path"}, {CLICK_QUERY_ERROR_NO_PACKAGE_DIR, "CLICK_QUERY_ERROR_NO_PACKAGE_DIR", "no-package-dir"}, {0, NULL, NULL}};
	GType click_query_error_type_id;
	click_query_error_type_id = g_enum_register_static ("ClickQueryError", values);
	return click_query_error_type_id;
}

GType
click_query_error_get_type (void)
{
	static volatile gsize click_query_error_type_id__once = 0;
	if (g_once_init_enter (&click_query_error_type_id__once)) {
		GType click_query_error_type_id;
		click_query_error_type_id = click_query_error_get_type_once ();
		g_once_init_leave (&click_query_error_type_id__once, click_query_error_type_id);
	}
	return click_query_error_type_id__once;
}

gchar*
click_find_package_directory (const gchar* path,
                              GError** error)
{
	gchar* dir = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	GError* _tmp16_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 32 "query.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 36 "query.vala"
	_tmp0_ = realpath (path, NULL);
#line 36 "query.vala"
	dir = _tmp0_;
#line 37 "query.vala"
	_tmp1_ = dir;
#line 37 "query.vala"
	if (_tmp1_ == NULL) {
#line 88 "query.c"
		const gchar* _tmp2_;
		GError* _tmp3_;
#line 38 "query.vala"
		_tmp2_ = g_strerror (errno);
#line 38 "query.vala"
		_tmp3_ = g_error_new (CLICK_QUERY_ERROR, CLICK_QUERY_ERROR_PATH, "Failed to canonicalize %s: %s", path, _tmp2_);
#line 38 "query.vala"
		_inner_error0_ = _tmp3_;
#line 38 "query.vala"
		if (_inner_error0_->domain == CLICK_QUERY_ERROR) {
#line 38 "query.vala"
			g_propagate_error (error, _inner_error0_);
#line 38 "query.vala"
			_g_free0 (dir);
#line 38 "query.vala"
			return NULL;
#line 105 "query.c"
		} else {
#line 38 "query.vala"
			_g_free0 (dir);
#line 38 "query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 38 "query.vala"
			g_clear_error (&_inner_error0_);
#line 38 "query.vala"
			return NULL;
#line 115 "query.c"
		}
	}
	{
		gboolean _tmp4_ = FALSE;
#line 42 "query.vala"
		_tmp4_ = TRUE;
#line 42 "query.vala"
		while (TRUE) {
#line 124 "query.c"
			gchar* info_dir = NULL;
			const gchar* _tmp6_;
			gchar* _tmp7_;
			const gchar* _tmp8_;
			const gchar* _tmp9_;
			gchar* new_dir = NULL;
			const gchar* _tmp10_;
			gchar* _tmp11_;
			const gchar* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			gchar* _tmp15_;
#line 42 "query.vala"
			if (!_tmp4_) {
#line 139 "query.c"
				const gchar* _tmp5_;
#line 52 "query.vala"
				_tmp5_ = dir;
#line 52 "query.vala"
				if (!(_tmp5_ != NULL)) {
#line 52 "query.vala"
					break;
#line 147 "query.c"
				}
			}
#line 42 "query.vala"
			_tmp4_ = FALSE;
#line 43 "query.vala"
			_tmp6_ = dir;
#line 43 "query.vala"
			_tmp7_ = g_build_filename (_tmp6_, ".click", "info", NULL);
#line 43 "query.vala"
			info_dir = _tmp7_;
#line 44 "query.vala"
			_tmp8_ = info_dir;
#line 44 "query.vala"
			if (click_is_dir (_tmp8_)) {
#line 45 "query.vala"
				result = dir;
#line 45 "query.vala"
				_g_free0 (info_dir);
#line 45 "query.vala"
				return result;
#line 168 "query.c"
			}
#line 46 "query.vala"
			_tmp9_ = dir;
#line 46 "query.vala"
			if (g_strcmp0 (_tmp9_, ".") == 0) {
#line 47 "query.vala"
				_g_free0 (info_dir);
#line 47 "query.vala"
				break;
#line 178 "query.c"
			}
#line 48 "query.vala"
			_tmp10_ = dir;
#line 48 "query.vala"
			_tmp11_ = g_path_get_dirname (_tmp10_);
#line 48 "query.vala"
			new_dir = _tmp11_;
#line 49 "query.vala"
			_tmp12_ = new_dir;
#line 49 "query.vala"
			_tmp13_ = dir;
#line 49 "query.vala"
			if (g_strcmp0 (_tmp12_, _tmp13_) == 0) {
#line 50 "query.vala"
				_g_free0 (new_dir);
#line 50 "query.vala"
				_g_free0 (info_dir);
#line 50 "query.vala"
				break;
#line 198 "query.c"
			}
#line 51 "query.vala"
			_tmp14_ = new_dir;
#line 51 "query.vala"
			_tmp15_ = g_strdup (_tmp14_);
#line 51 "query.vala"
			_g_free0 (dir);
#line 51 "query.vala"
			dir = _tmp15_;
#line 42 "query.vala"
			_g_free0 (new_dir);
#line 42 "query.vala"
			_g_free0 (info_dir);
#line 212 "query.c"
		}
	}
#line 54 "query.vala"
	_tmp16_ = g_error_new (CLICK_QUERY_ERROR, CLICK_QUERY_ERROR_NO_PACKAGE_DIR, "No package directory found for %s", path);
#line 54 "query.vala"
	_inner_error0_ = _tmp16_;
#line 54 "query.vala"
	if (_inner_error0_->domain == CLICK_QUERY_ERROR) {
#line 54 "query.vala"
		g_propagate_error (error, _inner_error0_);
#line 54 "query.vala"
		_g_free0 (dir);
#line 54 "query.vala"
		return NULL;
#line 227 "query.c"
	} else {
#line 54 "query.vala"
		_g_free0 (dir);
#line 54 "query.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 54 "query.vala"
		g_clear_error (&_inner_error0_);
#line 54 "query.vala"
		return NULL;
#line 237 "query.c"
	}
}

